#include "../include/aacrypt-general.h"

int start_check(char *password) {
  FILE *fhdictfile = NULL;
  char plain[65];
  
  switch(aacrypt_mode) {
	case AACRYPT_MD5:
          if(dictionary_file) {
	  	apsr_output("Checking for password in dictionary file.\n");
		fhdictfile = open_dictionary_file(dictionary_file);
		encryption_md5_dict(password, fhdictfile);
		close_dictionary_file(fhdictfile);
	        apsr_output("Password wasn't found in dictionary file.\n");
          }
	  break;
  	case AACRYPT_DES:
          if(dictionary_file) {
	    apsr_output("Checking for password in dictionary file.\n");
	    fhdictfile = open_dictionary_file(dictionary_file);
	    encryption_des_dict(password, fhdictfile);
	    close_dictionary_file(fhdictfile);
	    apsr_output("Password wasn't found in dictionary file.\n");
	  }
	  if(incremental) {
		  apsr_output("Starting incremental mode.\n");
		  encryption_des_incr(password);
		  apsr_output("Password not found.\n");
	  }
	  break;
        case AACRYPT_CISCO:
          if(decrypt_cisco_passwd(password, plain) == -1) {
		  apsr_stream_output((int) stderr, "Error: Cannot read the password.\n");
		  return(RET_FAILURE);
	  }
	  else 
		  apsr_output("Password is: %s\n", plain);
	  break;
	default:
	  break;
  }
  
  return(RET_SUCCESS);
}
