#include "../include/aacrypt-general.h"

int encryption_des_dict(char *password, FILE *fhdictfile) {
  static unsigned char *encrypt_des, dict_line[ MAX_LINE], *strip, des_salt[ 3];

  des_salt[0] = password[0];
  des_salt[1] = password[1];
  des_salt[2] = '\0';
		  
  while(fgets(dict_line, sizeof(dict_line), fhdictfile)) {
	  if ((strip = strchr(dict_line, '\n'))) {
		  *strip = '\0';
  	  }
          encrypt_des = (char *) crypt(dict_line, des_salt);

          if(strcmp(encrypt_des, password) == 0) {
		  apsr_output("Password is: %s\n", dict_line);
		  close_dictionary_file(fhdictfile);
                  exit(EXIT_SUCCESS);
          }
  }  

  return(RET_SUCCESS);
}

int encryption_des_incr(char *password) {
  static unsigned char *encrypt_des, temp_password[9], des_salt[ 3];
  static unsigned int i, j, k, l, m, n;
 
  des_salt[0] = password[0];
  des_salt[1] = password[1];
  des_salt[2] = '\0';
  
  if(incremental == 1 || incremental == 99) {
    apsr_output("Checking for one character passwords.\n");
    temp_password[1] = '\0'; 	// One character passwords
    for (i = 33; i < 126; i++) {  // Every 7 bit printable ascii character
          temp_password[0] = i;
  	  encrypt_des = crypt(temp_password, des_salt);
 	  if (strcmp(password, encrypt_des) == 0) {
		  apsr_output("Password is: %s\n", temp_password);
                  exit(EXIT_SUCCESS);
          }
    }
  }

  if(incremental == 2 || incremental == 99) { 
    apsr_output("Checking for two character passwords.\n");   
    temp_password[2] = '\0';	// Two character passwords
    for (i = 33; i < 126; i++) {  // Every 7 bit printable ascii character
      for (j = 33; j < 126; j++) {	  
	    temp_password[0] = i;
	    temp_password[1] = j;
            encrypt_des = crypt(temp_password, des_salt);
            if (strcmp(password, encrypt_des) == 0) {
		    apsr_output("Password is: %s\n", temp_password);
		    exit(EXIT_SUCCESS);
            }
      }
    }		       
  }
  
  if(incremental == 3 || incremental == 99) {
    apsr_output("Checking for three character passwords.\n");
    temp_password[3] = '\0';      // Three character passwords
    for (i = 33; i < 126; i++) {  // Every 7 bit printable ascii character
      for (j = 33; j < 126; j++) {
        for (k = 33; k < 126; k++) {
	      temp_password[0] = i;
              temp_password[1] = j;
	      temp_password[2] = k;
              encrypt_des = crypt(temp_password, des_salt);
              if (strcmp(password, encrypt_des) == 0) {
		      apsr_output("Password is: %s\n", temp_password);
                      exit(EXIT_SUCCESS);
              }
        }
      }
    }
  }
  
  if(incremental == 4 || incremental == 99) {
    apsr_output("Checking for four character passwords.\n");
    temp_password[4] = '\0';      // Four character passwords
    for (i = 33; i < 126; i++) {  // Every 7 bit printable ascii character
      for (j = 33; j < 126; j++) {
        for (k = 33; k < 126; k++) {
     	  for (l = 33; l < 126; l++) {
 		temp_password[0] = i;
  	        temp_password[1] = j;
	        temp_password[2] = k;
	        temp_password[3] = l;
	        encrypt_des = crypt(temp_password, des_salt);
                if (strcmp(password, encrypt_des) == 0) {
			apsr_output("Password is: %s\n", temp_password);
	                exit(EXIT_SUCCESS);
	        }
          }
        }
      }
    }
  }
  
  if(incremental == 5 || incremental == 99) {
    apsr_output("Checking for five character passwords.\n");
    temp_password[5] = '\0';      // Five character passwords
    for (i = 33; i < 126; i++) {  // Every 7 bit printable ascii character
      for (j = 33; j < 126; j++) {
        for (k = 33; k < 126; k++) {
   	  for (l = 33; l < 126; l++) {
            for (m = 33; m < 126; m++) {
	   	  temp_password[0] = i;
  	          temp_password[1] = j;
	          temp_password[2] = k;
	          temp_password[3] = l;
		  temp_password[4] = m;
	          encrypt_des = crypt(temp_password, des_salt);
                  if (strcmp(password, encrypt_des) == 0) {
			  apsr_output("Password is: %s\n", temp_password);
	                  exit(EXIT_SUCCESS);
	          }
  	    }
          }
        }
      }
    }  
  }

  if(incremental == 6 || incremental == 99) {
    apsr_output("Checking for six character passwords.\n");
    temp_password[6] = '\0';      // Six character passwords
    for (i = 33; i < 126; i++) {  // Every 7 bit printable ascii character
      for (j = 33; j < 126; j++) {
        for (k = 33; k < 126; k++) {
          for (l = 33; l < 126; l++) {
            for (m = 33; m < 126; m++) {
              for (n = 33; n < 126; n++) {
		    temp_password[0] = i;
		    temp_password[1] = j;
		    temp_password[2] = k;
		    temp_password[3] = l;
              	    temp_password[4] = m;
		    temp_password[4] = n;
                    encrypt_des = crypt(temp_password, des_salt);
                    if (strcmp(password, encrypt_des) == 0) {
			    apsr_output("Password is: %s\n", temp_password);
                            exit(EXIT_SUCCESS);
	            }
              }
            }
          }
        }
      }
    }
  }
 
  return(RET_SUCCESS);
}
