#include "../include/aacrypt-general.h"

int show_version=0;

int parseoptions (int argc, char *argv[]) {
  static struct gengetopt_args_info args_info;
  static int i;

  if(cmd_parser (argc, argv, &args_info) != 0) {
	  apsr_stream_output((int) stderr, "Error: Unable to parse the command line!\n");
  	  exit(EXIT_FAILURE);
  }

  if(args_info.help_given) usage(argv[0], "");
  if(args_info.version_given) showversion();
  
  if(args_info.type_given) {
    if(strncmp(args_info.type_arg, "md5", strlen(args_info.type_arg)) == 0) {
	    aacrypt_mode = AACRYPT_MD5;
	    apsr_output("Using MD5 encryption.\n");
    }
    else if(strncmp(args_info.type_arg, "des", strlen(args_info.type_arg)) == 0) {
	    aacrypt_mode = AACRYPT_DES;
            apsr_output("Using DES encryption.\n");
  }
    else if(strncmp(args_info.type_arg, "cisco", strlen(args_info.type_arg)) == 0)  {
	    aacrypt_mode = AACRYPT_CISCO;
            apsr_output("Using Cisco decryption.\n");
    }
    else {
            usage(argv[0], "Unknown chipertext type!");
    }			    
  }

  if(args_info.dictionary_given) {
    dictionary_file = malloc(strlen(args_info.dictionary_arg));
    strncpy(dictionary_file, args_info.dictionary_arg,
	    strlen(args_info.dictionary_arg));
  }

  if(args_info.length_given)
    incremental = args_info.length_arg;
  
  if(!dictionary_file && !incremental && (aacrypt_mode != AACRYPT_CISCO)) usage(argv[0], "You must at least set one option!");

  i = argc - 1;
  #ifndef AACRYPT_DEBUG
  while(i>0) {
	  memset(argv[i], '\0', strlen(argv[i]));
	  i--;
  }
  #endif
  
  start_check(args_info.password_arg);
    
  return(RET_SUCCESS);
}
