#include "../include/aacrypt-general.h"
 
int usage (char *name, char *error_str) {
  apsr_stream_output((int) stderr,
"\nAACRYPT v%s - Programmed by the APSR - Team\n"
"=============================================\n"
"Usage: %s -p <Password> -t <Type> [Option]\n"
" -p <Password>                  Encrypted password\n"
" -t <Type>                      Chipertext type (des|md5|cisco)\n\n"
" -d <Dictionary file>           Dictionary file to use\n"
" -i <Length>                    Incremental mode(des only), check up to 6 chars,\n                                99 for all lengths, 1-6 for a specific length\n\n"
" -h    --help			Display this help message\n"
" -V    --version		Display the version\n",
    AACRYPT_VERSION, name);
  
  if(*error_str) {
	  apsr_stream_output((int) stderr, "\nError: %s\n", error_str); 
	  exit(EXIT_FAILURE);
  }

  apsr_stream_output((int) stderr, "\n");

  exit(EXIT_SUCCESS);
}

/* TODO */
int showversion (void) {
  apsr_stream_output((int) stderr, "\nAACRYPT version %s (c) by the APSR - Team (questions@aa-security.de).\n\n", AACRYPT_VERSION);
  exit(EXIT_SUCCESS);
}
