#include <stdio.h>
#include <stdlib.h>
#include <apsrlib/apsrlib.h>
#include <openssl/md5.h>

int main(int argc, char *argv[]) {
  FILE *fhdigestfile;
  MD5_CTX context;
  size_t len;
  int i;
  unsigned char buffer[1024], digest[16];
  char md5_string[32];

  if((fhdigestfile = fopen(argv[1], "rb")) == NULL) {
    apsr_stream_output((int *) stderr, "\nError: Can't open file : %s.\n", argv[1]);
    exit(1);
  }

  MD5_Init(&context);
  while(len = fread(buffer, 1, 1024, fhdigestfile))
    MD5_Update(&context, buffer, len); 
  MD5_Final(digest, &context);

  fclose(fhdigestfile);

  for(i = 0; i < 16; i++) 
    sprintf(&(md5_string[i*2]), "%02x", digest[i]);
  apsr_output("%s  %s\n", md5_string, argv[1]);

  return(RET_SUCCESS);
} 

/* Compile with : gcc md5sum.c -lssl -o md5sum */
