#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libxml/xmlmemory.h>
#include <libxml/parser.h>

#define DEBUG

int main (void) {
	xmlDocPtr doc;
	xmlNodePtr cur;
	xmlNodePtr curchild;
	//xmlParserCtxtPtr ctxt;
	xmlChar *key;
	char *buf;
	
	buf=malloc(1024);
	memset(buf, '\0', 1024);
	strcpy((char *) buf, "<packet><info><number>1</number><arrival>03:50:06.024896</arrival><length>42</length></info><ethernet><destination>ff:ff:ff:ff:ff:ff</destination><source>00:c0:df:e8:94:89</source><typeII>0x0806</typeII></ethernet><info><number>1</number><arrival>03:50:06.024896</arrival><length>42</length></info><ethernet><destination>00:00:00:00:00:00</destination><source>20:c4:ff:00:12:23</source><typeII>0x0806</typeII></ethernet></packet>");
	printf("%s\n", buf);

	doc = xmlParseMemory(buf, strlen(buf));

	if (doc == NULL ) {
		fprintf(stderr,"Document not parsed successfully. \n");
		return(-1);
	}

	cur = xmlDocGetRootElement(doc);
	
	if (cur == NULL) {
		fprintf(stderr,"empty document\n");
		xmlFreeDoc(doc);
		return(-1);
	}

	if (xmlStrcmp(cur->name, (const xmlChar *) "packet")) {
		fprintf(stderr,"document of the wrong type, root node != packet\n");
		xmlFreeDoc(doc);
		return(-1);
	}

	cur = cur->xmlChildrenNode;
	while (cur != NULL) {
		printf("Parsing %s...\n", cur->name);
			
		curchild = cur->xmlChildrenNode;

		while (curchild != NULL) {
			if(curchild->xmlChildrenNode != NULL) {
				key = xmlNodeListGetString(doc, curchild->xmlChildrenNode, 1);
				printf("%s = %s\n", curchild->name, key);
				xmlFree(key);

				curchild=curchild->next;
			}
		}
		cur=cur->next;
	}

	xmlFreeDoc(doc);
	return(0);
}

