#include <stdlib.h>
#include <gtk/gtk.h>
#include <apsrlib/apsrlib.h>
#include "include.h"


/* start aprecv gui */
int check_options(GtkWidget *);
int insert_text(char);



GtkWidget *view1;
GtkTextBuffer *TextBuffer[21];

GtkWidget *notebook, *view[21], *scrolled_window[21], *vpaned[21], *sitelabel[21];
GtkWidget *above_table[21], *label[21], *start_stop[21];
unsigned short int window_nbr=0;

unsigned short int counter=2;

struct options {
  char *device;
  char *filter;
  char daemon1;
  char promisc;
  char count;
  char statistic;
  unsigned short int snaplen;
  unsigned short int maxpackets;
  char errorcheck;
  char checksum;
  char *expand;
  char verbose;
  char *logfile;
  char *logfile_raw;
  char print_raw_hex;
  char *print_proto_hex;
  char *print_proto_text;
  char *module;
  char module_raw;
  char module_ignore;
  char *serveraddr;
  char *serverport;
  char version;
}opt;

pid_t pid;

int button_pressed(void){
	static unsigned short int value;
	unsigned short int notebook_page;

	notebook_page=gtk_notebook_get_current_page(GTK_NOTEBOOK(notebook));

	if(value==0){
		gtk_button_set_label(GTK_BUTTON(start_stop[notebook_page]), "Start");
		value=1;
	}else{
		gtk_button_set_label(GTK_BUTTON(start_stop[notebook_page]), "Stop");
		value=0;
	}
	
	return(RET_SUCCESS);
}

int draw_filter_window(void){

	if(window_nbr > 21)
		return(RET_FAILURE);
	
	above_table[window_nbr]=gtk_table_new(2,1,FALSE);
	label[window_nbr]=gtk_label_new("Filter");
	
	gtk_widget_set_usize(label[window_nbr], 50, 20);
	gtk_label_set_justify(GTK_LABEL(label[window_nbr]), GTK_JUSTIFY_LEFT);
	start_stop[window_nbr]=gtk_button_new_with_label("Stop");
	gtk_signal_connect(GTK_OBJECT(start_stop[window_nbr]), "clicked", GTK_SIGNAL_FUNC(button_pressed), NULL);
	gtk_table_attach_defaults(GTK_TABLE(above_table[window_nbr]), GTK_WIDGET(label[window_nbr]), 0,1,0,1);
	gtk_table_attach_defaults(GTK_TABLE(above_table[window_nbr]), GTK_WIDGET(start_stop[window_nbr]),1,2,0,1);
	scrolled_window[window_nbr]=gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window[window_nbr]), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	vpaned[window_nbr]=gtk_vpaned_new();
	view[window_nbr]=gtk_text_view_new();
	TextBuffer[window_nbr]=gtk_text_view_get_buffer(GTK_TEXT_VIEW(view[window_nbr]));
	gtk_container_add(GTK_CONTAINER(scrolled_window[window_nbr]), GTK_WIDGET(view[window_nbr]));
	sitelabel[window_nbr]=gtk_label_new("APSR-Window");
	gtk_notebook_append_page(GTK_NOTEBOOK(notebook),vpaned[window_nbr], sitelabel[window_nbr]);
	gtk_paned_add1(GTK_PANED(vpaned[window_nbr]), scrolled_window[window_nbr]);
	gtk_paned_add2(GTK_PANED(vpaned[window_nbr]), above_table[window_nbr]);
	gtk_paned_set_position(GTK_PANED(vpaned[window_nbr]), 510);
	gtk_widget_show_all(notebook);
	window_nbr++;

	return(RET_SUCCESS);
}

int apsend_version_func(void){
 	GtkWidget *dialog;
	FILE *file;
	gchar *version_number;
        version_number=malloc(20);
        file=fopen("/usr/src/apsr-0.16/apsend-0.01/doc/VERSION", "r");
        fscanf(file, "%s", version_number);
        dialog=gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, "apsend Version: %s", version_number);
        gtk_dialog_run(GTK_DIALOG(dialog));
        gtk_widget_destroy(dialog);
	return(0);
}

int aprecv_version_func(void){
	GtkWidget *dialog;
        FILE *file;
        gchar *version_number;
        version_number=malloc(20);
        file=fopen("/usr/src/apsr-0.16/aprecv-0.11/doc/VERSION", "r");
        fscanf(file, "%s", version_number);
        dialog=gtk_message_dialog_new(NULL, GTK_DIALOG_MODAL , GTK_MESSAGE_INFO, GTK_BUTTONS_OK,  "aprecv Version: %s", version_number);
        printf("%s", version_number);
        gtk_dialog_run(GTK_DIALOG(dialog));
        gtk_widget_destroy(dialog);
 	return(0);
}
			
int insert_buffer(GtkTextBuffer *buffer){
	GtkTextIter iter;
	FILE *file;
	char *buf;


	gtk_text_buffer_get_iter_at_offset(buffer, &iter, 0);
	buf=malloc(82);
	file=fopen("apsrlib.txt", "r");
	while((fgets(buf, 82, file)) != NULL)
		gtk_text_buffer_insert(buffer, &iter, buf, -1);
	return(RET_SUCCESS);
}

static void print_doc(void){
	GtkWidget *dialog, *view, *button, *scrolled_window;
	GtkTextBuffer *buffer;


	dialog=gtk_dialog_new();
	gtk_widget_set_usize(GTK_WIDGET(dialog), 900,600);
	view=gtk_text_view_new();
	buffer=gtk_text_view_get_buffer(GTK_TEXT_VIEW(view));
	scrolled_window=gtk_scrolled_window_new(NULL,NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	button=gtk_button_new_with_label("OK");
	gtk_container_add(GTK_CONTAINER(scrolled_window), view);
	gtk_box_set_homogeneous(GTK_BOX(GTK_DIALOG(dialog)->vbox), FALSE);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), scrolled_window, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), button, TRUE, TRUE,0);
	insert_buffer(buffer);
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_WIDGET(dialog));
	gtk_widget_show_all(dialog);
}

/*void new_filter_window(void){
	GtkWidget *sitelabel, *label;
	char *count;
	
	count=malloc(sizeof(int));
	sprintf(count, "Seite %u", counter);
        label=gtk_label_new("fups");
	sitelabel=gtk_label_new(count);
        gtk_notebook_append_page(GTK_NOTEBOOK(notebook), label, sitelabel);
        counter++;
	gtk_widget_show_all(notebook);
}*/

int insert_text(char c){
	GtkTextIter iter;
	/*char *bla;
	bla=malloc(2);
	sprintf(bla, "%c", c);*/
	TextBuffer[window_nbr]=gtk_text_view_get_buffer(GTK_TEXT_VIEW(view[window_nbr]));
	gtk_text_buffer_get_iter_at_offset(TextBuffer[window_nbr], &iter, 0);

	gtk_text_buffer_insert(TextBuffer[window_nbr], &iter, "test\ntest\nfoo", -1);
	return(0);
}


	
int check_options(GtkWidget *window){
  //FILE *pipe;
  char exec_buf[1024];
  char temp[1024];
  //char buffer;
  //char c;
  exec_buf[0]='\0';

  sprintf(temp, "aprecv ");
  strcat(exec_buf, temp);
  if(opt.device != NULL) {
    sprintf(temp, "-d %s ", opt.device);
    strcat(exec_buf, temp);
  }
  if(opt.filter != NULL){
    sprintf(temp, "-f \"%s\" ", opt.filter);
    strcat(exec_buf, temp);
  }
  if(opt.daemon1 != 0){
    sprintf(temp, "-D ");
    strcat(exec_buf, temp);
  }
  if(opt.promisc != 0){
    sprintf(temp, "-p %u ", opt.promisc);
    strcat(exec_buf, temp);
  }
  if(opt.count != 0){
    sprintf(temp, "-c ");
    strcat(exec_buf, temp);
  }
  if(opt.statistic != 0){
    sprintf(temp, "--statistic ");
    strcat(exec_buf, temp);
  }
  if(opt.snaplen != 0){
    sprintf(temp, "-s %u ", opt.snaplen);
    strcat(exec_buf, temp);
  }
  if(opt.maxpackets !=0){
    sprintf(temp, "--max-packets %u ", opt.maxpackets);
    strcat(exec_buf, temp);
  }
  if(opt.errorcheck != 0){
    sprintf(temp, "--check-for-errors ");
    strcat(exec_buf, temp);
  }
  if(opt.checksum != 0){
    sprintf(temp, "--calc-checksums ");
    strcat(exec_buf, temp);
  }
  if(opt.expand != NULL){
    sprintf(temp, "--expand-%s ", opt.expand);
    strcat(exec_buf, temp);
  }
  if(opt.verbose != 0){
    sprintf(temp, "--verbose ");
    strcat(exec_buf, temp);
  }

  if(opt.logfile != NULL){
    sprintf(temp, "-l %s ",opt.logfile);
    strcat(exec_buf, temp);
  }
  if(opt.logfile_raw != NULL){
    sprintf(temp, "-r %s ",opt.logfile_raw);
    strcat(exec_buf,temp);
  }
  if(opt.print_raw_hex != 0){
    sprintf(temp, "-R ");
    strcat(exec_buf, temp);
  }
  if(opt.print_proto_hex != NULL){
    sprintf(temp, "--print-%s-hex ", opt.print_proto_hex);
    strcat(exec_buf, temp);
  }
  if(opt.print_proto_text != NULL){
    sprintf(temp, "--print-%s-text ", opt.print_proto_text);
    strcat(exec_buf, temp);
  }
  if(opt.module != NULL){
    sprintf(temp, "--module %s ", opt.module);
    strcat(exec_buf, temp);
  }
  if(opt.module_raw != 0){
    sprintf(temp, "--module-raw ");
    strcat(exec_buf, temp);
  }
  if(opt.module_ignore != 0){
    sprintf(temp, "--module-ignore ");
    strcat(exec_buf, temp);
  }
  if(opt.serveraddr != NULL){
    sprintf(temp, "--server-addr %s ", opt.serveraddr);
    strcat(exec_buf, temp);
  }
  if(opt.serverport !=NULL){
    sprintf(temp, "--server-port %s ", opt.serverport);
    strcat(exec_buf, temp);
  }
  if(opt.version != 0){
    /*pipe=popen("aprecv --version", "r");
    while((c=getc(pipe)) != EOF)
      ;//g_print("%c",c);
    pclose(pipe);
    g_print("\n");*/
    return(RET_SUCCESS);
  }

 
 

  //sprintf(temp, "\n");
  //strcat(exec_buf, temp);

  /*if((pid=fork()) == 0){
    pipe=popen(exec_buf, "r");
    //while((buffer=getc(pipe)) != EOF)
      insert_text(buffer);

    pclose(pipe);
  }*/
  return(RET_SUCCESS);
}

static gint clicked_ok(GtkWidget *window) {

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(device))) {
    if(strlen(gtk_entry_get_text(GTK_ENTRY(device_txt))) != 0)
      opt.device=g_strdup(gtk_entry_get_text(GTK_ENTRY(device_txt)));
    else
      opt.device=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(filter))) {
    if(strlen(gtk_entry_get_text(GTK_ENTRY(filter_txt))) != 0)
      opt.filter=g_strdup(gtk_entry_get_text(GTK_ENTRY(filter_txt)));
    else
      opt.filter=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(daemon1)))
    opt.daemon1=1;
  else
    opt.daemon1=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(promisc)))
    opt.promisc=atoi(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(promisc_box)->entry)));

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(count)))
    opt.count=1;
  else
    opt.count=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(statistic)))
    opt.statistic=1;
  else
    opt.statistic=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(snaplen))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(snaplen_txt))) != 0)
      opt.snaplen=atoi(gtk_entry_get_text(GTK_ENTRY(snaplen_txt)));
    else
      opt.snaplen=0;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(max_packets))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(max_packets_txt))) != 0)
      opt.maxpackets=atoi(gtk_entry_get_text(GTK_ENTRY(max_packets_txt)));
    else
      opt.maxpackets=0;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(check_for_errors)))
    opt.errorcheck=1;
  else
    opt.errorcheck=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(calc_checksums)))
    opt.checksum=1;
  else
    opt.checksum=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(expand))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(expand_txt))) != 0)
      opt.expand=g_strdup(gtk_entry_get_text(GTK_ENTRY(expand_txt)));
    else
      opt.expand=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(verbose)))
    opt.verbose=1;
  else
    opt.verbose=0;


  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(logfile))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(logfile_txt))) != 0)
      opt.logfile=g_strdup(gtk_entry_get_text(GTK_ENTRY(logfile_txt)));
    else
      opt.logfile=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(logfile_raw))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(logfile_raw_txt))) != 0)
      opt.logfile_raw=g_strdup(gtk_entry_get_text(GTK_ENTRY(logfile_raw_txt)));
    else
      opt.logfile_raw=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(print_raw_hex)))
    opt.print_raw_hex=1;
  else
    opt.print_raw_hex=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(print_proto_hex))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(print_proto_hex_txt))) != 0)
      opt.print_proto_hex=g_strdup(gtk_entry_get_text(GTK_ENTRY(print_proto_hex_txt)));
    else
      opt.print_proto_hex=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(print_proto_text))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(print_proto_text_txt))) != 0)
      opt.print_proto_text=g_strdup(gtk_entry_get_text(GTK_ENTRY(print_proto_text_txt)));
    else
      opt.print_proto_text=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(module))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(module_txt))) != 0)
      opt.module=g_strdup(gtk_entry_get_text(GTK_ENTRY(module_txt)));
    else
      opt.module=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(module_raw)))
    opt.module_raw=1;
  else
    opt.module_raw=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(module_ignore)))
    opt.module_ignore=1;
  else
    opt.module_ignore=0;

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(server_addr))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(server_addr_txt))) != 0)
      opt.serveraddr=g_strdup(gtk_entry_get_text(GTK_ENTRY(server_addr_txt)));
    else
      opt.serveraddr=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(server_port))){
    if(strlen(gtk_entry_get_text(GTK_ENTRY(server_port_txt))) != 0)
      opt.serverport=g_strdup(gtk_entry_get_text(GTK_ENTRY(server_port_txt)));
    else
      opt.serverport=NULL;
  }

  if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(aprecv_version)))
    opt.version=1;
  else
    opt.version=0;

  check_options(window);
  return(RET_SUCCESS);
}


/*static void exit_aprecv(GtkWidget *window) {
  kill(pid, 9);
  gtk_main_quit();
}*/


static void aprecv(GtkWidget *w, gpointer data)
{
  GtkWidget *window;
  GtkWidget *table1, *button_ok, *button_no;

  /*create stuff*/
  window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_default_size(GTK_WINDOW(window), 290, 585);

  table1=gtk_table_new(25,3,FALSE);
  button_ok=gtk_button_new_with_label("OK");
  button_no=gtk_button_new_with_label("Cancel");

  device_txt=gtk_entry_new();
  filter_txt=gtk_entry_new();
  snaplen_txt=gtk_entry_new();
  max_packets_txt=gtk_entry_new();
  expand_txt=gtk_entry_new();
  logfile_txt=gtk_entry_new();
  logfile_raw_txt=gtk_entry_new();
  print_proto_hex_txt=gtk_entry_new();
  print_proto_text_txt=gtk_entry_new();
  module_txt=gtk_entry_new();
  server_addr_txt=gtk_entry_new();
  server_port_txt=gtk_entry_new();

  promisc_box=gtk_combo_new();
  promisc_data=g_list_append(promisc_data, "0");
  promisc_data=g_list_append(promisc_data, "1");
  gtk_combo_set_popdown_strings(GTK_COMBO(promisc_box), promisc_data);
  gtk_combo_set_use_arrows(GTK_COMBO(promisc_box), 1);

  /* create check buttons */
  device=gtk_check_button_new_with_label("Device to open");
  filter=gtk_check_button_new_with_label("Set bpf filter rule, optimized");
  daemon1=gtk_check_button_new_with_label("Run as deamon");
  promisc=gtk_check_button_new_with_label("Promisc mode on/off, default on");
  count=gtk_check_button_new_with_label("Count all bytes received");
  statistic=gtk_check_button_new_with_label("Count all packets recieved");
  snaplen=gtk_check_button_new_with_label("Set the snaplen for pcap");
  max_packets=gtk_check_button_new_with_label("Maximus packets to receive, default is loop");
  check_for_errors=gtk_check_button_new_with_label("Check for errors in packets and print them");
  calc_checksums=gtk_check_button_new_with_label("Calculate checksums, print correct if wrong");
  expand=gtk_check_button_new_with_label("Expand the given protocol header");
  verbose=gtk_check_button_new_with_label("Print out more information");
  logfile=gtk_check_button_new_with_label("File to log the packets(hex)");
  logfile_raw=gtk_check_button_new_with_label("File to log the packets(raw)");
  print_raw_hex=gtk_check_button_new_with_label("Print raw packet in hex");
  print_proto_hex=gtk_check_button_new_with_label("Print payload of the given protocol in hex");
  print_proto_text=gtk_check_button_new_with_label("Print payload of the given protocol in text");
  module=gtk_check_button_new_with_label("Load the given shared module");
  module_raw=gtk_check_button_new_with_label("Give the whole packet to the module");
  module_ignore=gtk_check_button_new_with_label("Ignore the builtin BPF filter of the module");
  server_addr=gtk_check_button_new_with_label("Open connection to APSR server");
  server_port=gtk_check_button_new_with_label("Connect to the given port");
  aprecv_version=gtk_check_button_new_with_label("Display the version");


  /* packing check buttons into table */
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(device), 0,1,0,1);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(device_txt), 1,2,0,1);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(filter), 0,1,1,2);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(filter_txt), 1,2,1,2);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(daemon1), 0,1,2,3);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(promisc), 0,1,3,4);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(promisc_box), 1,2,3,4);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(count), 0,1,4,5);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(statistic), 0,1,5,6);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(snaplen), 0,1,6,7);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(snaplen_txt), 1,2,6,7);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(max_packets), 0,1,7,8);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(max_packets_txt), 1,2,7,8);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(check_for_errors), 0,1,8,9);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(calc_checksums), 0,1,9,10);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(expand), 0,1,10,11);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(expand_txt), 1,2,10,11);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(verbose), 0,1,11,12);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(logfile), 0,1,12,13);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(logfile_txt), 1,2,12,13);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(logfile_raw), 0,1,13,14);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(logfile_raw_txt), 1,2,13,14);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(print_raw_hex), 0,1,14,15);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(print_proto_hex), 0,1,15,16);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(print_proto_hex_txt), 1,2,15,16);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(print_proto_text), 0,1,16,17);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(print_proto_text_txt), 1,2,16,17);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(module), 0,1,17,18);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(module_txt), 1,2,17,18);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(module_raw), 0,1,18,19);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(module_ignore), 0,1,19,20);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(server_addr), 0,1,20,21);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(server_addr_txt), 1,2,20,21);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(server_port), 0,1,21,22);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(server_port_txt), 1,2,21,22);

  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(aprecv_version), 0,1,22,23);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(button_ok), 0,1,24,25);
  gtk_table_attach_defaults(GTK_TABLE(table1), GTK_WIDGET(button_no), 1,2,24,25);

  /* Set Signal Handlers */
  gtk_signal_connect_object(GTK_OBJECT(button_no), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_WIDGET(window));
  gtk_signal_connect(GTK_OBJECT(button_ok), "clicked", GTK_SIGNAL_FUNC(clicked_ok), NULL);

  
  gtk_container_add(GTK_CONTAINER(window), table1);
  gtk_widget_show_all(window);
}


/* End of aprecv gui */

int main(int argc, char *argv[])
{
  GtkWidget *dialog, *image;	
  GtkWidget *window, *menuBar;
  GtkAccelGroup *accel_group;
  GtkItemFactory *item_factory;
  GtkWidget *table;
  GtkWidget *button_table;
  GtkWidget *button1, *button2, *button3, *button4, *button5;
 
  static GtkItemFactoryEntry menu_items[] = {
    { "/_File", NULL, NULL, 0, "<Branch>"},
    { "/File/_New Filter Window", "<control>f", draw_filter_window, 0, NULL},
    { "/File/_Quit", "<control>d", gtk_main_quit, 0, NULL},
    { "/_aprecv", NULL, NULL, 0, "<Branch>"},
    { "/aprecv/_capture..", "<control>r", aprecv, 0, NULL},
    { "/aprecv/_version", NULL, aprecv_version_func, 0, NULL},
    { "/_apsend", NULL, NULL, 0, "<Branch>"},
    { "/apsend/_send..", "<control>s", NULL, 0, NULL},
    { "/apsend/_version", NULL, apsend_version_func, 0, NULL},
    { "/_Help", NULL, NULL, 0, "<Branch>"},
    { "/Help/_Documentation", "<control>p", NULL, 0, NULL},
    { "/Help/_APSRLIB", "<control>l", print_doc, 0, NULL},
  };  
      gtk_init(&argc, &argv);
      
      /*APSR-LOGO*/
      alarm(2);
      signal(SIGALRM, gtk_main_quit);
      dialog=gtk_dialog_new();
      image=gtk_image_new_from_file("logo.png");
      gtk_container_add(GTK_CONTAINER(GTK_DIALOG(dialog)->vbox), image);
      gtk_widget_show(image);
      gtk_widget_show_all(dialog);
      gtk_main();

      table=gtk_table_new(1,2,FALSE); 
      
      button_table=gtk_table_new(5,1, FALSE);
      button1=gtk_button_new_with_label("Button1");
      button2=gtk_button_new_with_label("Button2");
      button3=gtk_button_new_with_label("Button3");
      button4=gtk_button_new_with_label("Button4");
      button5=gtk_button_new_with_label("Button5");
      gtk_table_attach_defaults(GTK_TABLE(button_table), GTK_WIDGET(button1), 0,1,0,1);
      gtk_table_attach_defaults(GTK_TABLE(button_table), GTK_WIDGET(button2), 1,2,0,1);
      gtk_table_attach_defaults(GTK_TABLE(button_table), GTK_WIDGET(button3), 2,3,0,1);
      gtk_table_attach_defaults(GTK_TABLE(button_table), GTK_WIDGET(button4), 3,4,0,1);
      gtk_table_attach_defaults(GTK_TABLE(button_table), GTK_WIDGET(button5), 4,5,0,1);
      
      
      
      
      notebook=gtk_notebook_new();    
      gtk_notebook_set_scrollable(GTK_NOTEBOOK(notebook), TRUE);
      draw_filter_window();
      window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
      gtk_window_set_title(GTK_WINDOW(window), "APSR-GUI");
      gtk_widget_set_usize(GTK_WIDGET(window), 900,600);
 
      gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);
      accel_group= gtk_accel_group_new();
      item_factory = gtk_item_factory_new(
		      GTK_TYPE_MENU_BAR, "<main>", accel_group);
      gtk_item_factory_create_items(item_factory, sizeof(menu_items)/
		      sizeof(GtkItemFactoryEntry), menu_items, NULL);
      gtk_window_add_accel_group(GTK_WINDOW(window), accel_group);
      menuBar=gtk_item_factory_get_widget(item_factory, "<main>");
      gtk_table_attach(GTK_TABLE(table), GTK_WIDGET(menuBar), 0,1,0,1, GTK_FILL | GTK_EXPAND, 0, 0,0);
      gtk_table_attach(GTK_TABLE(table), GTK_WIDGET(notebook), 0,1,1,2, GTK_FILL | GTK_EXPAND, GTK_FILL | GTK_EXPAND ,0,0);
   
      gtk_container_add(GTK_CONTAINER(window), GTK_WIDGET(table));

      gtk_widget_show_all(window);
      gtk_widget_destroy(dialog);
      gtk_main();
      return(0);
}
