/* Connection state / rfc 793 */
#define APSRSTACK_TCP_STATE_LISTEN		1
#define APSRSTACK_TCP_STATE_SYN_SENT		2
#define APSRSTACK_TCP_STATE_SYN_RECEIVED	3
#define APSRSTACK_TCP_STATE_ESTABLISHED		4
#define APSRSTACK_TCP_STATE_FIN_WAIT_1		5
#define APSRSTACK_TCP_STATE_FIN_WAIT_2		6
#define APSRSTACK_TCP_STATE_CLOSE_WAIT		7
#define APSRSTACK_TCP_STATE_CLOSING		8
#define APSRSTACK_TCP_STATE_LAST_ACK		9
#define APSRSTACK_TCP_STATE_TIME_WAIT		10
#define APSRSTACK_TCP_STATE_CLOSED		11

struct tcp_connection {
  unsigned char state;		/* Connection state */
  unsigned char last_flag;	/* Last flag from peer */
  struct in_addr peer_ip;	/* IPv4 address of peer */
  unsigned short local_port;	/* Local port */
  unsigned short peer_port;	/* Port of peer */
  unsigned int seq_next;	/* Sequence number, we expect from peer */
  unsigned int last_seq;	/* Last sequence number from us */
  unsigned int ack_next;	/* Next ack sequence number from peer */
  unsigned short mss;		/* Maximum segment size */
};

#define APSRSTACK_TCP_MAX_PORTS			65535
#define APSRSTACK_TCP_MAX_CONNECTIONS           255

struct tcp_connection tcp_queue[APSRSTACK_TCP_MAX_CONNECTIONS];

unsigned short tcp_listen_ports[APSRSTACK_TCP_MAX_PORTS];

