#include "../include/apsrlib-config.h"

int apsr_xml (char *buf) {
	#ifdef HAVE_APSRLIB_XML2_SUPPORT
	xmlDocPtr doc;
	xmlNodePtr cur;
	xmlNodePtr cur_child;
	xmlChar *key;

	doc = xmlParseMemory(buf, strlen(buf));

	if(doc == NULL) {
		ERROR("XML buffer not parsed successfully.");
		return(RET_FAILURE);
	}

	cur = xmlDocGetRootElement(doc);

	if(cur == NULL) {
		ERROR("XML buffer empty.");
		return(RET_FAILURE);
	}

	if(xmlStrcmp(cur->name, (const xmlChar *) "packet")) {
		ERROR("XML buffer of the wrong type, root node != packet.");
		xmlFreeDoc(doc);
		return(RET_FAILURE);
	}

	cur = cur->xmlChildrenNode;

	while(cur != NULL) {
		#ifdef APSRLIB_DEBUG
		printf("Parsing %s...\n", cur->name);
		#endif

		cur_child = cur->xmlChildrenNode;

		while(cur_child != NULL) {
			if(cur_child->xmlChildrenNode != NULL) {
				key = xmlNodeListGetString(doc, cur_child->xmlChildrenNode, 1);
				printf("%s = %s\n", cur_child->name, key);
				xmlFree(key);

				cur_child = cur_child->next;
			}
		}

		cur = cur->next;
	}

	xmlFreeDoc(doc);
	
	#else
	printf("%s", buf);
	#endif

	return(RET_SUCCESS);
}

